#include <stdio.h>
#include "../CpuInfo/CpuInfo.h"
#include "../CpuInfo/CpuInfoID.h"

// Device Driver Status
int gFlagStatus;

int main()
{
	char str[256];

	CCpuInfo* CPU = new CCpuInfo
#ifdef _WIN32
		(1)
#endif
;
	printf("----------------------------------------------------------------\n");
	printf("CrystalCPUID %s.%s (C) 2002-2003 MIYAZAKI Noriyuki\n", CRYSTAL_CPUID_VERSION, CPU_INFO_VERSION );
    printf("                    Crystal Dew World [http://crystalmark.info/]\n");
	printf("----------------------------------------------------------------\n");

	printf("       CPU Name : %s\n",CPU->GetInfo(CPU_NAME, str) );
	printf("      Code Name : %s\n",CPU->GetInfo(CPU_CODE_NAME, str) );
	printf("  Vendor String : %s\n",CPU->GetInfo(CPU_VENDOR_STRING, str) );
	printf("    Name String : %s\n",CPU->GetInfo(CPU_NAME_STRING, str) );
	printf("       Platform : %s\n",CPU->GetInfo(CPU_PLATFORM_NAME, str) );
//	printf("           Type : %s\n",CPU->GetInfo(CPU_TYPE_NAME, str) );
	printf("          CPUID : %s\n",CPU->GetInfo(CPU_FMS, str) );
	printf("       Brand ID : %s\n",CPU->GetInfo(CPU_BRAND_ID, str) );
	printf("          Clock : %7s MHz\n",CPU->GetInfo(CPU_CLOCK, str) );
#ifdef _WIN32
	printf("   System Clock : %7s MHz\n",CPU->GetInfo(CPU_SYSTEM_CLOCK, str) );
	printf("     System Bus : %7s MHz\n",CPU->GetInfo(CPU_SYSTEM_BUS, str) );
	printf("     Multiplier : %7s\n",CPU->GetInfo(CPU_MULTIPLIER, str) );
#endif
	printf("        Feature : ");
	DWORD data;
	CPU->GetData(CPU_FLAG_MMX, &data);		if( data ){printf("MMX ");}
	CPU->GetData(CPU_FLAG_SSE, &data);		if( data ){printf("SSE ");}
	CPU->GetData(CPU_FLAG_SSE2, &data);		if( data ){printf("SSE2 ");}
	CPU->GetData(CPU_FLAG_SSE3, &data);		if( data ){printf("SSE3 ");}
	CPU->GetData(CPU_FLAG_MMX_EX, &data);	if( data ){printf("MMX+ ");}
	CPU->GetData(CPU_FLAG_3DNOW, &data);	if( data ){printf("3DNow! ");}
	CPU->GetData(CPU_FLAG_3DNOW_EX, &data);	if( data ){printf("3DNow!+ ");}
	CPU->GetData(CPU_FLAG_HTT, &data);		if( data ){printf("HTT ");}
	CPU->GetData(CPU_FLAG_IA64, &data);		if( data ){printf("IA-64 ");}
	CPU->GetData(CPU_FLAG_AA64, &data);		if( data ){printf("AA-64 ");}
	printf("\n");

	delete CPU;

	return 0;
}
